import plugin from "@start/plugin";
export default (userOptions => plugin('babel', ({
  logPath
}) => async ({
  files
}) => {
  // @ts-ignore
  const {
    transformAsync
  } = await import('@babel/core');
  return {
    files: await Promise.all(files.map(async file => {
      const options = { ...userOptions,
        ast: false,
        inputSourceMap: file.map != null ? file.map : false,
        filename: file.path
      };
      const result = await transformAsync(file.data, options);
      logPath(file.path);
      return {
        path: file.path,
        data: result.code,
        map: result.map
      };
    }))
  };
}));